library dllmapped;

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

const
  WM_DATA = WM_USER + 1024;
  MAPFILESIZE = 1000;
  REQUEST_TIMEOUT = 1000;

type
  PShareMem = ^TShareMem;
  TShareMem = record
    Data: array[0..255] of char;
  end;

var
  PShare: PShareMem;
  hMapping: THandle;
  hMapMutex: THandle;



{$R *.RES}

procedure OpenMap( MapName:string );
begin
   {Ыؤ@ӤMgֹH}
  HMapping := CreateFileMapping(
    $FFFFFFFF,
    nil,
    PAGE_READWRITE,
    0,
    SizeOf(TShareMem),
                 {oӤMg󪺦WrΩPLi{@θӪ,}
   pchar( MapName )
    );
  if (hMapping = 0) then
  begin
    ShowMessage('ЫذOMg');
    exit;
  end;
   (*NƬMgi{}Ŷ
   ЫؤF@ӤMg󤧫,Mtd󪺸ƫOd
    @Ӧ}Ŷϰ,ñN󪺸Ƨ@dMgӰϰ쪺zOi洣C*)
  PShare := PShareMem(MapViewOfFile(HMapping, FILE_MAP_ALL_ACCESS, 0, 0, 0));
  if PShare = nil then
  begin
    CloseHandle(HMapping);
    ShowMessage('Can''t View Memory Map');
    exit;
  end;

  (*JMڭ̳qLpvFileoFMHϪ_la},liHϰ@Ǿާ@F*)
end;

procedure CloseMap;
begin
  if PShare <> nil then
    {qi{}ŶMPƪMH}
    UnMapViewOfFile(PShare);
  if HMapping <> 0 then
    CloseHandle(HMapping);
end;

function LockMap: Boolean;
begin
  Result := true;
   {Ыؤ}
  HMapMutex := CreateMutex(nil, false,
    pchar('MY MUTEX NAME GOES HERE'));
  if HMapMutex = 0 then
  begin
    ShowMessage('Ыؤ');
    Result := false;
  end else begin
    if WaitForSingleObject(HMapMutex, REQUEST_TIMEOUT)
      = WAIT_FAILED then
    begin
      ShowMessage('郎[!');
      Result := false;
    end
  end
end;

procedure UnlockMap;
begin
   {MgM󪫥}
  ReleaseMutex(HMapMutex);
  CloseHandle(HMapMutex);
end;

procedure WriteMap(astring:string);
var
  str: pchar;
begin
  str := pchar(astring);
  ZeroMemory(@(pShare^.data), 254);(*MŬMgOа϶ 11:50~dw*)
  CopyMemory(@(pShare^.data), Str, Length(str));(*JMgOа϶*)
end;

function ReadFromMap(astring:string):pchar;
var
  MapHandle : THandle;
begin
  MapHandle := OpenFileMapping(FILE_MAP_WRITE, (*XݬMg*)
    False, (*i~Ӫ*)
    pchar(astring)); (*MgɮצWr*)
  if MapHandle = 0 then
  begin
    ShowMessage('wOMg!');
    Halt;
  end;
  (*oOMg*)
  PShare := PShareMem(MapViewOfFile(MapHandle, FILE_MAP_ALL_ACCESS, 0, 0, 0));
  if PShare = nil then
  begin
    CloseHandle(MapHandle);
    ShowMessage('Lk˵OMg');
    halt;
  end;
  FillChar(PShare^, SizeOf(TShareMem), 0);
  result := PShare^.Data;
end;

exports
  OpenMap,
  CloseMap,
  LockMap,
  UnlockMap,
  readfrommap,
  WriteMap;


begin
end.
